// WindowTrackerDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "WindowTracker.h"
#include "WindowTrackerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWindowTrackerDlg Dialogfeld

CWindowTrackerDlg::CWindowTrackerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWindowTrackerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWindowTrackerDlg)
	m_fHideWnd = FALSE;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pLastWnd=NULL;
	m_fCapture=FALSE;
}

void CWindowTrackerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWindowTrackerDlg)
	DDX_Control(pDX, IDC_TARGET, m_Target);
	DDX_Check(pDX, IDC_HIDEWND, m_fHideWnd);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_LIST, m_WndList);
}

BEGIN_MESSAGE_MAP(CWindowTrackerDlg, CDialog)
	//{{AFX_MSG_MAP(CWindowTrackerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWindowTrackerDlg Nachrichten-Handler

BOOL CWindowTrackerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	m_WndList.InsertColumn(0,_T("HWND"),LVCFMT_LEFT,60,0);
	m_WndList.InsertColumn(1,_T("Class"),LVCFMT_LEFT,200,1);
	m_WndList.InsertColumn(2,_T("Title"),LVCFMT_LEFT,200,2);


	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CWindowTrackerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CWindowTrackerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CWindowTrackerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Main action of program: Tracks mouse movement and checks windows
void CWindowTrackerDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_fCapture)
	{
		const size_t BuffSize=128;
		CString temp(_T('\0'),BuffSize);
		CWnd *pCurrentWnd;

		//Show screen coordinates of cursor
		ClientToScreen(&point);
		pCurrentWnd=WindowFromPoint(point);
		temp.Format(_T("x: %i y: %i"),(int)point.x,(int)point.y);
		SetWindowText(temp);

		if(m_pLastWnd != pCurrentWnd)
		{
			MarkWindow(m_pLastWnd); //Unmark old window
			MarkWindow(pCurrentWnd); //Mark new window
			
			m_pLastWnd=pCurrentWnd; //Changing to new window
			if(NULL != m_pLastWnd)
			{
				//Insert HWND
				temp.Format(_T("%.8X"),m_pLastWnd->m_hWnd);
				m_WndList.InsertItem(0,temp);

				//Insert window class name
				temp.ReleaseBuffer(::GetClassName(m_pLastWnd->m_hWnd,temp.GetBuffer(BuffSize),BuffSize));
				m_WndList.SetItem(0,1,LVIF_TEXT,temp,0,0,0,0,0);

				//Insert window title
				m_pLastWnd->GetWindowText(temp);
				m_WndList.SetItem(0,2,LVIF_TEXT,temp,0,0,0,0,0);
			}
		}
	}
	
	CDialog::OnMouseMove(nFlags, point);
}

void CWindowTrackerDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(m_fCapture)		//User selected window
	{
		MarkWindow(m_pLastWnd); //Unmark window

		::ReleaseCapture();
		m_fCapture=FALSE;
		ShowWindow(SW_SHOW);
		
		return;
	}

	CDialog::OnLButtonUp(nFlags, point);
}

void CWindowTrackerDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	UpdateData(TRUE); //DDX

	CRect rc;
	m_Target.GetWindowRect(&rc);
	ClientToScreen(&point);
	
	if(rc.PtInRect(point))
	{
		SetCursor(AfxGetApp()->LoadCursor(IDC_TARGETCURSOR));
		if(m_fHideWnd) ShowWindow(SW_HIDE);
		
		m_fCapture=TRUE;
		SetCapture();
		return;
	}
	
	CDialog::OnLButtonDown(nFlags, point);
}

CWindowTrackerDlg::~CWindowTrackerDlg()
{

}

void CWindowTrackerDlg::MarkWindow(CWnd* pWnd)
{
	if(NULL == pWnd) return;
		
	CDC *dc=pWnd->GetWindowDC();
	
	//Draw rect
	CRect rect;
	pWnd->GetWindowRect(&rect);
	rect.DeflateRect(1,1,1,1);
	CSize size=rect.Size();
	rect.left=1;rect.top=1;rect.right=size.cx;rect.bottom=size.cy;
	dc->DrawFocusRect(&rect);

	pWnd->ReleaseDC(dc);
}